Loading...
Searching...
No Matches
ON_Mesh Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_mesh.h>`

Inheritance diagram for ON_Mesh:

## Public Member Functions

| ON_Mesh ()
| ON_Mesh (int initial_face_array_capacity, int initial_vertex_array_capacity, bool has_vertex_normals, bool has_texture_coordinates)
| ON_Mesh (const ON_Mesh &)
ON_Mesh & | operator= (const ON_Mesh &)
| ~ON_Mesh ()
void | MemoryRelocate ()
void | DestroyRuntimeCache (bool bDelete=true)
void | Destroy ()
void | EmergencyDestroy ()
void | DestroyTree (bool bDeleteTree=true)
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
ON::object_type | ObjectType () const
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
ON_BOOL32 | Transform (const ON_Xform &)
bool | IsDeformable () const
bool | MakeDeformable ()
ON_BOOL32 | SwapCoordinates (int, int)
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
bool | SetVertex (int, const ON_3dPoint &)
bool | SetVertex (int, const ON_3fPoint &)
bool | SetVertexNormal (int, const ON_3dVector &)
bool | SetVertexNormal (int, const ON_3fVector &)
bool | SetTextureCoord (int, double, double)
bool | SetTriangle (int, int, int, int)
bool | SetQuad (int, int, int, int, int)
ON_MeshVertexRef | VertexRef (ON_COMPONENT_INDEX ci) const
ON_MeshVertexRef | VertexRef (int mesh_V_index) const
ON_MeshEdgeRef | EdgeRef (ON_COMPONENT_INDEX ci) const
ON_MeshEdgeRef | EdgeRef (int tope_index) const
ON_MeshFaceRef | FaceRef (ON_COMPONENT_INDEX ci) const
ON_MeshFaceRef | FaceRef (int mesh_F_index) const
ON_Geometry * | MeshComponent (ON_COMPONENT_INDEX ci) const
int | VertexCount () const
int | FaceCount () const
int | QuadCount () const
int | TriangleCount () const
int | InvalidFaceCount () const
bool | HasVertexNormals () const
bool | HasFaceNormals () const
bool | HasTextureCoordinates () const
bool | HasSurfaceParameters () const
bool | HasPrincipalCurvatures () const
bool | HasVertexColors () const
int | HiddenVertexCount () const
bool | GetCurvatureStats (ON::curvature_style, ON_MeshCurvatureStats &) const
void | InvalidateVertexBoundingBox ()
void | InvalidateVertexNormalBoundingBox ()
void | InvalidateTextureCoordinateBoundingBox ()
void | InvalidateCurvatureStats ()
void | InvalidateBoundingBoxes ()
void | Flip ()
void | FlipVertexNormals ()
void | FlipFaceNormals ()
void | FlipFaceOrientation ()
void | SetMeshParameters (const ON_MeshParameters &)
const ON_MeshParameters * | MeshParameters () const
void | DeleteMeshParameters ()
bool | UnitizeVertexNormals ()
bool | UnitizeFaceNormals ()
bool | CountQuads ()
bool | ConvertQuadsToTriangles ()
bool | ConvertTrianglesToQuads (double angle_tol_radians, double min_diagonal_length_ratio)
bool | ComputeFaceNormals ()
bool | ComputeFaceNormal (int)
int | GetClashingFacePairs (int max_pair_count, ON_SimpleArray< ON_2dex > &clashing_pairs) const
int | CullClashingFaces (int what_to_cull)
int | CullDegenerateFaces ()
int | CullUnusedVertices ()
bool | Compact ()
bool | ComputeVertexNormals ()
bool | NormalizeTextureCoordinates ()
bool | TransposeTextureCoordinates ()
bool | TransposeSurfaceParameters ()
bool | ReverseTextureCoordinates (int dir)
bool | ReverseSurfaceParameters (int dir)
bool | SetTextureCoordinates (const class ON_TextureMapping &mapping, const class ON_Xform *mesh_xform=0, bool bLazy=true)
bool | HasCachedTextureCoordinates () const
const ON_TextureCoordinates * | CachedTextureCoordinates (const ON_UUID &mapping_id) const
const ON_TextureCoordinates * | SetCachedTextureCoordinates (const class ON_TextureMapping &mapping, const class ON_Xform *mesh_xform=0, bool bLazy=true)
bool | EvaluateMeshGeometry (const ON_Surface &)
bool | CombineCoincidentVertices (ON_3fVector, double)
bool | CombineIdenticalVertices (bool bIgnoreVertexNormals=false, bool bIgnoreTextureCoordinates=false)
void | Append (const ON_Mesh &)
void | Append (int count, const ON_Mesh *const *meshes)
void | SetClosed (int closed)
bool | IsClosed () const
bool | IsManifold () const
bool | IsOriented () const
bool | IsManifold (bool bTopologicalTest, bool *pbIsOriented=NULL, bool *pbHasBoundary=NULL) const
void | SetSolidOrientation (int solid_orientation)
int | SolidOrientation () const
bool | IsSolid () const
int | GetVertexEdges (int vcount, const int *vertex_index, bool bNoDuplicates, ON_SimpleArray< ON_2dex > &edges) const
int | GetMeshEdges (ON_SimpleArray< ON_2dex > &edges) const
int * | GetVertexLocationIds (int first_vid, int *Vid, int *Vindex) const
int | GetMeshFaceSideList (const int *Vid, struct ON_MeshFaceSide *&sides) const
int | GetMeshEdgeList (ON_SimpleArray< ON_2dex > &edge_list, int edge_type_partition[5]) const
int | GetMeshEdgeList (ON_SimpleArray< ON_2dex > &edge_list, ON_SimpleArray< int > &ci_meshtop_edge_map, int edge_type_partition[5]) const
int | GetMeshEdgeList (ON_SimpleArray< ON_2dex > &edge_list, ON_SimpleArray< int > &ci_meshtop_edge_map, ON_SimpleArray< int > &ci_meshtop_vertex_map, int edge_type_partition[5]) const
bool | CollapseEdge (int topei)
bool | IsSwappableEdge (int topei)
bool | SwapEdge (int topei)
bool | DeleteFace (int meshfi)
void | DestroyHiddenVertexArray ()
const bool * | HiddenVertexArray () const
void | SetVertexHiddenFlag (int meshvi, bool bHidden)
bool | VertexIsHidden (int meshvi) const
bool | FaceIsHidden (int meshvi) const
const ON_MeshTopology & | Topology () const
void | DestroyTopology ()
bool | TopologyExists () const
const ON_MeshPartition * | CreatePartition (int, int)
const ON_MeshPartition * | Partition () const
void | DestroyPartition ()
ON_Mesh * | MeshPart (const ON_MeshPart &mesh_part, ON_Mesh *mesh) const
ON_Mesh * | DuplicateFace (int face_index, ON_Mesh *mesh) const
const class ON_MeshNgonList * | NgonList () const
class ON_MeshNgonList * | ModifyNgonList ()
void | DestroyNgonList ()
int | GetConnectedComponents (bool bUseVertexConnections, bool bTopologicalConnections, ON_SimpleArray< int > &facet_component_labels) const
int | GetConnectedComponents (bool bUseVertexConnections, bool bTopologicalConnections, ON_SimpleArray< ON_Mesh * > *components) const
bool | HasSynchronizedDoubleAndSinglePrecisionVertices () const
bool | HasDoublePrecisionVertices () const
void | EnableDoublePrecisionVertices (bool bEnableDoublePrecisionVertices)
void | UpdateSinglePrecisionVertices ()
void | UpdateDoublePrecisionVertices ()
void | SetSinglePrecisionVerticesAsValid ()
void | SetDoublePrecisionVerticesAsValid ()
bool | SinglePrecisionVerticesAreValid () const
bool | DoublePrecisionVerticesAreValid () const
void | DestroyDoublePrecisionVertices ()
ON_3dPointArray & | DoublePrecisionVertices ()
const ON_3dPointArray & | DoublePrecisionVertices () const
ON_3fPointArray & | SinglePrecisionVertices ()
const ON_3fPointArray & | SinglePrecisionVertices () const
ON_3dPoint | Vertex (int vertex_index) const
bool | HasPackedTextureRegion () const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual void | ClearBoundingBox ()
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Public Attributes

ON_3fPointArray | m_V
ON_SimpleArray< ON_MeshFace > | m_F
ON_3fVectorArray | m_N
ON_3fVectorArray | m_FN
ON_MappingTag | m_Ttag
ON_2fPointArray | m_T
ON_ClassArray< ON_TextureCoordinates > | m_TC
ON_2dPointArray | m_S
ON_Interval | m_srf_domain [2]
double | m_srf_scale [2]
ON_Interval | m_packed_tex_domain [2]
bool | m_packed_tex_rotate
ON_SimpleArray< ON_SurfaceCurvature > | m_K
ON_MappingTag | m_Ctag
ON_SimpleArray< ON_Color > | m_C
ON_SimpleArray< bool > | m_H
int | m_hidden_count
const ON_Object * | m_parent

## Protected Attributes

ON_MeshTopology | m_top
ON_MeshParameters * | m_mesh_parameters
int | m_invalid_count
int | m_quad_count
int | m_triangle_count
float | m_vbox [2][3]
float | m_nbox [2][3]
float | m_tbox [2][2]
ON_MeshCurvatureStats * | m_kstat [4]
ON_MeshPartition * | m_partition

## Friends

class | ON_MeshVertexRef
class | ON_MeshEdgeRef
class | ON_MeshFaceRef

## Detailed Description

Definition at line 989 of file opennurbs_mesh.h.

## Constructor & Destructor Documentation

## ON_Mesh() [1/3]

ON_Mesh::ON_Mesh | ( |  | ) |

## ON_Mesh() [2/3]

ON_Mesh::ON_Mesh | ( | int | initial_face_array_capacity,
|  | int | initial_vertex_array_capacity,
|  | bool | has_vertex_normals,
|  | bool | has_texture_coordinates
| ) |  |

## ON_Mesh() [3/3]

ON_Mesh::ON_Mesh | ( | const ON_Mesh & |  | ) |

## ~ON_Mesh()

ON_Mesh::~ON_Mesh | ( |  | ) |

## Member Function Documentation

## Append() [1/2]

void ON_Mesh::Append | ( | const ON_Mesh & |  | ) |

## Append() [2/2]

void ON_Mesh::Append | ( | int | count,
|  | const ON_Mesh *const * | meshes
| ) |  |

## CachedTextureCoordinates()

const ON_TextureCoordinates * ON_Mesh::CachedTextureCoordinates | ( | const ON_UUID & | mapping_id | ) | const

## CollapseEdge()

bool ON_Mesh::CollapseEdge | ( | int | topei | ) |

## CombineCoincidentVertices()

bool ON_Mesh::CombineCoincidentVertices | ( | ON_3fVector | ,
|  | double |
| ) |  |

## CombineIdenticalVertices()

bool ON_Mesh::CombineIdenticalVertices | ( | bool | bIgnoreVertexNormals = `false`,
|  | bool | bIgnoreTextureCoordinates = `false`
| ) |  |

## Compact()

bool ON_Mesh::Compact | ( |  | ) |

## ComputeFaceNormal()

bool ON_Mesh::ComputeFaceNormal | ( | int |  | ) |

## ComputeFaceNormals()

bool ON_Mesh::ComputeFaceNormals | ( |  | ) |

## ComputeVertexNormals()

bool ON_Mesh::ComputeVertexNormals | ( |  | ) |

## ConvertQuadsToTriangles()

bool ON_Mesh::ConvertQuadsToTriangles | ( |  | ) |

## ConvertTrianglesToQuads()

bool ON_Mesh::ConvertTrianglesToQuads | ( | double | angle_tol_radians,
|  | double | min_diagonal_length_ratio
| ) |  |

## CountQuads()

bool ON_Mesh::CountQuads | ( |  | ) |

## CreatePartition()

const ON_MeshPartition * ON_Mesh::CreatePartition | ( | int | ,
|  | int |
| ) |  |

## CullClashingFaces()

int ON_Mesh::CullClashingFaces | ( | int | what_to_cull | ) |

## CullDegenerateFaces()

int ON_Mesh::CullDegenerateFaces | ( |  | ) |

## CullUnusedVertices()

int ON_Mesh::CullUnusedVertices | ( |  | ) |

## DataCRC()

ON__UINT32 ON_Mesh::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

## DeleteFace()

bool ON_Mesh::DeleteFace | ( | int | meshfi | ) |

## DeleteMeshParameters()

void ON_Mesh::DeleteMeshParameters | ( |  | ) |

## Destroy()

void ON_Mesh::Destroy | ( |  | ) |

## DestroyDoublePrecisionVertices()

void ON_Mesh::DestroyDoublePrecisionVertices | ( |  | ) |

## DestroyHiddenVertexArray()

void ON_Mesh::DestroyHiddenVertexArray | ( |  | ) |

## DestroyNgonList()

void ON_Mesh::DestroyNgonList | ( |  | ) |

## DestroyPartition()

void ON_Mesh::DestroyPartition | ( |  | ) |

## DestroyRuntimeCache()

void ON_Mesh::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_Object.

## DestroyTopology()

void ON_Mesh::DestroyTopology | ( |  | ) |

## DestroyTree()

void ON_Mesh::DestroyTree | ( | bool | bDeleteTree = `true` | ) |

## Dimension()

int ON_Mesh::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## DoublePrecisionVertices() [1/2]

ON_3dPointArray & ON_Mesh::DoublePrecisionVertices | ( |  | ) |

## DoublePrecisionVertices() [2/2]

const ON_3dPointArray & ON_Mesh::DoublePrecisionVertices | ( |  | ) | const

## DoublePrecisionVerticesAreValid()

bool ON_Mesh::DoublePrecisionVerticesAreValid | ( |  | ) | const

## Dump()

void ON_Mesh::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## DuplicateFace()

ON_Mesh * ON_Mesh::DuplicateFace | ( | int | face_index,
|  | ON_Mesh * | mesh
| ) |  | const

## EdgeRef() [1/2]

ON_MeshEdgeRef ON_Mesh::EdgeRef | ( | int | tope_index | ) | const

## EdgeRef() [2/2]

ON_MeshEdgeRef ON_Mesh::EdgeRef | ( | ON_COMPONENT_INDEX | ci | ) | const

## EmergencyDestroy()

void ON_Mesh::EmergencyDestroy | ( |  | ) |

## EnableDoublePrecisionVertices()

void ON_Mesh::EnableDoublePrecisionVertices | ( | bool | bEnableDoublePrecisionVertices | ) |

## EvaluateMeshGeometry()

bool ON_Mesh::EvaluateMeshGeometry | ( | const ON_Surface & |  | ) |

## EvaluatePoint()

bool ON_Mesh::EvaluatePoint | ( | const class ON_ObjRef & | objref,
|  | ON_3dPoint & | P
| ) |  | const

virtual

Reimplemented from ON_Geometry.

## FaceCount()

int ON_Mesh::FaceCount | ( |  | ) | const

## FaceIsHidden()

bool ON_Mesh::FaceIsHidden | ( | int | meshvi | ) | const

## FaceRef() [1/2]

ON_MeshFaceRef ON_Mesh::FaceRef | ( | int | mesh_F_index | ) | const

## FaceRef() [2/2]

ON_MeshFaceRef ON_Mesh::FaceRef | ( | ON_COMPONENT_INDEX | ci | ) | const

## Flip()

void ON_Mesh::Flip | ( |  | ) |

## FlipFaceNormals()

void ON_Mesh::FlipFaceNormals | ( |  | ) |

## FlipFaceOrientation()

void ON_Mesh::FlipFaceOrientation | ( |  | ) |

## FlipVertexNormals()

void ON_Mesh::FlipVertexNormals | ( |  | ) |

## GetBBox()

ON_BOOL32 ON_Mesh::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetClashingFacePairs()

int ON_Mesh::GetClashingFacePairs | ( | int | max_pair_count,
|  | ON_SimpleArray< ON_2dex > & | clashing_pairs
| ) |  | const

## GetConnectedComponents() [1/2]

int ON_Mesh::GetConnectedComponents | ( | bool | bUseVertexConnections,
|  | bool | bTopologicalConnections,
|  | ON_SimpleArray< int > & | facet_component_labels
| ) |  | const

## GetConnectedComponents() [2/2]

int ON_Mesh::GetConnectedComponents | ( | bool | bUseVertexConnections,
|  | bool | bTopologicalConnections,
|  | ON_SimpleArray< ON_Mesh * > * | components
| ) |  | const

## GetCurvatureStats()

bool ON_Mesh::GetCurvatureStats | ( | ON::curvature_style | ,
|  | ON_MeshCurvatureStats & |
| ) |  | const

## GetMeshEdgeList() [1/3]

int ON_Mesh::GetMeshEdgeList | ( | ON_SimpleArray< ON_2dex > & | edge_list,
|  | int | edge_type_partition[5]
| ) |  | const

## GetMeshEdgeList() [2/3]

int ON_Mesh::GetMeshEdgeList | ( | ON_SimpleArray< ON_2dex > & | edge_list,
|  | ON_SimpleArray< int > & | ci_meshtop_edge_map,
|  | int | edge_type_partition[5]
| ) |  | const

## GetMeshEdgeList() [3/3]

int ON_Mesh::GetMeshEdgeList | ( | ON_SimpleArray< ON_2dex > & | edge_list,
|  | ON_SimpleArray< int > & | ci_meshtop_edge_map,
|  | ON_SimpleArray< int > & | ci_meshtop_vertex_map,
|  | int | edge_type_partition[5]
| ) |  | const

## GetMeshEdges()

int ON_Mesh::GetMeshEdges | ( | ON_SimpleArray< ON_2dex > & | edges | ) | const

## GetMeshFaceSideList()

int ON_Mesh::GetMeshFaceSideList | ( | const int * | Vid,
|  | struct ON_MeshFaceSide *& | sides
| ) |  | const

## GetTightBoundingBox()

bool ON_Mesh::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

virtual

Reimplemented from ON_Geometry.

## GetVertexEdges()

int ON_Mesh::GetVertexEdges | ( | int | vcount,
|  | const int * | vertex_index,
|  | bool | bNoDuplicates,
|  | ON_SimpleArray< ON_2dex > & | edges
| ) |  | const

## GetVertexLocationIds()

int * ON_Mesh::GetVertexLocationIds | ( | int | first_vid,
|  | int * | Vid,
|  | int * | Vindex
| ) |  | const

## HasCachedTextureCoordinates()

bool ON_Mesh::HasCachedTextureCoordinates | ( |  | ) | const

## HasDoublePrecisionVertices()

bool ON_Mesh::HasDoublePrecisionVertices | ( |  | ) | const

## HasFaceNormals()

bool ON_Mesh::HasFaceNormals | ( |  | ) | const

## HasPackedTextureRegion()

bool ON_Mesh::HasPackedTextureRegion | ( |  | ) | const

## HasPrincipalCurvatures()

bool ON_Mesh::HasPrincipalCurvatures | ( |  | ) | const

## HasSurfaceParameters()

bool ON_Mesh::HasSurfaceParameters | ( |  | ) | const

## HasSynchronizedDoubleAndSinglePrecisionVertices()

bool ON_Mesh::HasSynchronizedDoubleAndSinglePrecisionVertices | ( |  | ) | const

## HasTextureCoordinates()

bool ON_Mesh::HasTextureCoordinates | ( |  | ) | const

## HasVertexColors()

bool ON_Mesh::HasVertexColors | ( |  | ) | const

## HasVertexNormals()

bool ON_Mesh::HasVertexNormals | ( |  | ) | const

## HiddenVertexArray()

const bool * ON_Mesh::HiddenVertexArray | ( |  | ) | const

## HiddenVertexCount()

int ON_Mesh::HiddenVertexCount | ( |  | ) | const

## InvalidateBoundingBoxes()

void ON_Mesh::InvalidateBoundingBoxes | ( |  | ) |

## InvalidateCurvatureStats()

void ON_Mesh::InvalidateCurvatureStats | ( |  | ) |

## InvalidateTextureCoordinateBoundingBox()

void ON_Mesh::InvalidateTextureCoordinateBoundingBox | ( |  | ) |

## InvalidateVertexBoundingBox()

void ON_Mesh::InvalidateVertexBoundingBox | ( |  | ) |

## InvalidateVertexNormalBoundingBox()

void ON_Mesh::InvalidateVertexNormalBoundingBox | ( |  | ) |

## InvalidFaceCount()

int ON_Mesh::InvalidFaceCount | ( |  | ) | const

## IsClosed()

bool ON_Mesh::IsClosed | ( |  | ) | const

## IsDeformable()

bool ON_Mesh::IsDeformable | ( |  | ) | const

virtual

Reimplemented from ON_Geometry.

## IsManifold() [1/2]

bool ON_Mesh::IsManifold | ( |  | ) | const

## IsManifold() [2/2]

bool ON_Mesh::IsManifold | ( | bool | bTopologicalTest,
|  | bool * | pbIsOriented = `NULL`,
|  | bool * | pbHasBoundary = `NULL`
| ) |  | const

## IsOriented()

bool ON_Mesh::IsOriented | ( |  | ) | const

## IsSolid()

bool ON_Mesh::IsSolid | ( |  | ) | const

## IsSwappableEdge()

bool ON_Mesh::IsSwappableEdge | ( | int | topei | ) |

## IsValid()

ON_BOOL32 ON_Mesh::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## MakeDeformable()

bool ON_Mesh::MakeDeformable | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

## MemoryRelocate()

void ON_Mesh::MemoryRelocate | ( |  | ) |

virtual

Reimplemented from ON_Object.

## MeshComponent()

ON_Geometry * ON_Mesh::MeshComponent | ( | ON_COMPONENT_INDEX | ci | ) | const

## MeshParameters()

const ON_MeshParameters * ON_Mesh::MeshParameters | ( |  | ) | const

## MeshPart()

ON_Mesh * ON_Mesh::MeshPart | ( | const ON_MeshPart & | mesh_part,
|  | ON_Mesh * | mesh
| ) |  | const

## ModifyNgonList()

class ON_MeshNgonList * ON_Mesh::ModifyNgonList | ( |  | ) |

## NgonList()

const class ON_MeshNgonList * ON_Mesh::NgonList | ( |  | ) | const

## NormalizeTextureCoordinates()

bool ON_Mesh::NormalizeTextureCoordinates | ( |  | ) |

## ObjectType()

ON::object_type ON_Mesh::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## operator=()

ON_Mesh & ON_Mesh::operator= | ( | const ON_Mesh & |  | ) |

## Partition()

const ON_MeshPartition * ON_Mesh::Partition | ( |  | ) | const

## QuadCount()

int ON_Mesh::QuadCount | ( |  | ) | const

## Read()

ON_BOOL32 ON_Mesh::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## ReverseSurfaceParameters()

bool ON_Mesh::ReverseSurfaceParameters | ( | int | dir | ) |

## ReverseTextureCoordinates()

bool ON_Mesh::ReverseTextureCoordinates | ( | int | dir | ) |

## SetCachedTextureCoordinates()

const ON_TextureCoordinates * ON_Mesh::SetCachedTextureCoordinates | ( | const class ON_TextureMapping & | mapping,
|  | const class ON_Xform * | mesh_xform = `0`,
|  | bool | bLazy = `true`
| ) |  |

## SetClosed()

void ON_Mesh::SetClosed | ( | int | closed | ) |

## SetDoublePrecisionVerticesAsValid()

void ON_Mesh::SetDoublePrecisionVerticesAsValid | ( |  | ) |

## SetMeshParameters()

void ON_Mesh::SetMeshParameters | ( | const ON_MeshParameters & |  | ) |

## SetQuad()

bool ON_Mesh::SetQuad | ( | int | ,
|  | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) |  |

## SetSinglePrecisionVerticesAsValid()

void ON_Mesh::SetSinglePrecisionVerticesAsValid | ( |  | ) |

## SetSolidOrientation()

void ON_Mesh::SetSolidOrientation | ( | int | solid_orientation | ) |

## SetTextureCoord()

bool ON_Mesh::SetTextureCoord | ( | int | ,
|  | double | ,
|  | double |
| ) |  |

## SetTextureCoordinates()

bool ON_Mesh::SetTextureCoordinates | ( | const class ON_TextureMapping & | mapping,
|  | const class ON_Xform * | mesh_xform = `0`,
|  | bool | bLazy = `true`
| ) |  |

## SetTriangle()

bool ON_Mesh::SetTriangle | ( | int | ,
|  | int | ,
|  | int | ,
|  | int |
| ) |  |

## SetVertex() [1/2]

bool ON_Mesh::SetVertex | ( | int | ,
|  | const ON_3dPoint & |
| ) |  |

## SetVertex() [2/2]

bool ON_Mesh::SetVertex | ( | int | ,
|  | const ON_3fPoint & |
| ) |  |

## SetVertexHiddenFlag()

void ON_Mesh::SetVertexHiddenFlag | ( | int | meshvi,
|  | bool | bHidden
| ) |  |

## SetVertexNormal() [1/2]

bool ON_Mesh::SetVertexNormal | ( | int | ,
|  | const ON_3dVector & |
| ) |  |

## SetVertexNormal() [2/2]

bool ON_Mesh::SetVertexNormal | ( | int | ,
|  | const ON_3fVector & |
| ) |  |

## SinglePrecisionVertices() [1/2]

ON_3fPointArray & ON_Mesh::SinglePrecisionVertices | ( |  | ) |

## SinglePrecisionVertices() [2/2]

const ON_3fPointArray & ON_Mesh::SinglePrecisionVertices | ( |  | ) | const

## SinglePrecisionVerticesAreValid()

bool ON_Mesh::SinglePrecisionVerticesAreValid | ( |  | ) | const

## SizeOf()

unsigned int ON_Mesh::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SolidOrientation()

int ON_Mesh::SolidOrientation | ( |  | ) | const

## SwapCoordinates()

ON_BOOL32 ON_Mesh::SwapCoordinates | ( | int | ,
|  | int |
| ) |  |

virtual

Reimplemented from ON_Geometry.

## SwapEdge()

bool ON_Mesh::SwapEdge | ( | int | topei | ) |

## Topology()

const ON_MeshTopology & ON_Mesh::Topology | ( |  | ) | const

## TopologyExists()

bool ON_Mesh::TopologyExists | ( |  | ) | const

## Transform()

ON_BOOL32 ON_Mesh::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## TransposeSurfaceParameters()

bool ON_Mesh::TransposeSurfaceParameters | ( |  | ) |

## TransposeTextureCoordinates()

bool ON_Mesh::TransposeTextureCoordinates | ( |  | ) |

## TriangleCount()

int ON_Mesh::TriangleCount | ( |  | ) | const

## UnitizeFaceNormals()

bool ON_Mesh::UnitizeFaceNormals | ( |  | ) |

## UnitizeVertexNormals()

bool ON_Mesh::UnitizeVertexNormals | ( |  | ) |

## UpdateDoublePrecisionVertices()

void ON_Mesh::UpdateDoublePrecisionVertices | ( |  | ) |

## UpdateSinglePrecisionVertices()

void ON_Mesh::UpdateSinglePrecisionVertices | ( |  | ) |

## Vertex()

ON_3dPoint ON_Mesh::Vertex | ( | int | vertex_index | ) | const

## VertexCount()

int ON_Mesh::VertexCount | ( |  | ) | const

## VertexIsHidden()

bool ON_Mesh::VertexIsHidden | ( | int | meshvi | ) | const

## VertexRef() [1/2]

ON_MeshVertexRef ON_Mesh::VertexRef | ( | int | mesh_V_index | ) | const

## VertexRef() [2/2]

ON_MeshVertexRef ON_Mesh::VertexRef | ( | ON_COMPONENT_INDEX | ci | ) | const

## Write()

ON_BOOL32 ON_Mesh::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Friends And Related Symbol Documentation

## ON_MeshEdgeRef

friend class ON_MeshEdgeRef

friend

Definition at line 2356 of file opennurbs_mesh.h.

## ON_MeshFaceRef

friend class ON_MeshFaceRef

friend

Definition at line 2357 of file opennurbs_mesh.h.

## ON_MeshVertexRef

friend class ON_MeshVertexRef

friend

Definition at line 2355 of file opennurbs_mesh.h.

## Member Data Documentation

## m_C

ON_SimpleArray<ON_Color> ON_Mesh::m_C

Definition at line 2336 of file opennurbs_mesh.h.

## m_Ctag

ON_MappingTag ON_Mesh::m_Ctag

Definition at line 2335 of file opennurbs_mesh.h.

## m_F

ON_SimpleArray<ON_MeshFace> ON_Mesh::m_F

Definition at line 2204 of file opennurbs_mesh.h.

## m_FN

ON_3fVectorArray ON_Mesh::m_FN

Definition at line 2216 of file opennurbs_mesh.h.

## m_H

ON_SimpleArray<bool> ON_Mesh::m_H

Definition at line 2343 of file opennurbs_mesh.h.

## m_hidden_count

int ON_Mesh::m_hidden_count

Definition at line 2347 of file opennurbs_mesh.h.

## m_invalid_count

int ON_Mesh::m_invalid_count

protected

Definition at line 2366 of file opennurbs_mesh.h.

## m_K

ON_SimpleArray<ON_SurfaceCurvature> ON_Mesh::m_K

Definition at line 2328 of file opennurbs_mesh.h.

## m_kstat

ON_MeshCurvatureStats* ON_Mesh::m_kstat[4]

protected

Definition at line 2382 of file opennurbs_mesh.h.

## m_mesh_parameters

ON_MeshParameters* ON_Mesh::m_mesh_parameters

protected

Definition at line 2364 of file opennurbs_mesh.h.

## m_N

ON_3fVectorArray ON_Mesh::m_N

Definition at line 2210 of file opennurbs_mesh.h.

## m_nbox

float ON_Mesh::m_nbox[2][3]

protected

Definition at line 2379 of file opennurbs_mesh.h.

## m_packed_tex_domain

ON_Interval ON_Mesh::m_packed_tex_domain[2]

Definition at line 2282 of file opennurbs_mesh.h.

## m_packed_tex_rotate

bool ON_Mesh::m_packed_tex_rotate

Definition at line 2313 of file opennurbs_mesh.h.

## m_parent

const ON_Object* ON_Mesh::m_parent

Definition at line 2352 of file opennurbs_mesh.h.

## m_partition

ON_MeshPartition* ON_Mesh::m_partition

protected

Definition at line 2385 of file opennurbs_mesh.h.

## m_quad_count

int ON_Mesh::m_quad_count

protected

Definition at line 2367 of file opennurbs_mesh.h.

## m_S

ON_2dPointArray ON_Mesh::m_S

Definition at line 2271 of file opennurbs_mesh.h.

## m_srf_domain

ON_Interval ON_Mesh::m_srf_domain[2]

Definition at line 2272 of file opennurbs_mesh.h.

## m_srf_scale

double ON_Mesh::m_srf_scale[2]

Definition at line 2273 of file opennurbs_mesh.h.

## m_T

ON_2fPointArray ON_Mesh::m_T

Definition at line 2227 of file opennurbs_mesh.h.

## m_tbox

float ON_Mesh::m_tbox[2][2]

protected

Definition at line 2381 of file opennurbs_mesh.h.

## m_TC

ON_ClassArray<ON_TextureCoordinates> ON_Mesh::m_TC

Definition at line 2236 of file opennurbs_mesh.h.

## m_top

ON_MeshTopology ON_Mesh::m_top

protected

Definition at line 2362 of file opennurbs_mesh.h.

## m_triangle_count

int ON_Mesh::m_triangle_count

protected

Definition at line 2368 of file opennurbs_mesh.h.

## m_Ttag

ON_MappingTag ON_Mesh::m_Ttag

Definition at line 2226 of file opennurbs_mesh.h.

## m_V

ON_3fPointArray ON_Mesh::m_V

Definition at line 2192 of file opennurbs_mesh.h.

## m_vbox

float ON_Mesh::m_vbox[2][3]

protected

Definition at line 2378 of file opennurbs_mesh.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_mesh.h